module Main where

import Prelude

import App (app)
import DOM.Simple (Element, boundingRect)
import DOM.Simple as DOM
import DOM.Simple.Console (log, log2)
import DOM.Simple.Document (document)
import DOM.Simple.Element (boundingRect)
import DOM.Simple.Types (DOMRect)
import Data.Maybe (Maybe(..))
import Data.Nullable (toMaybe, null)
import Data.Tuple (Tuple)
import Data.Tuple.Nested ((/\))
import Effect (Effect)
import Effect.Class (liftEffect)
import FFI.Simple ((...), delay, args2)
import Graphics.D3.Base 
import Phylo.Ressources as PR
import Phylo.Types as PT
import Reactix as R
import Reactix.DOM.HTML as H
import Toestand as T

main :: Effect Unit
main = paint $ toMaybe (document ... "getElementById" $ [ "app" ])

render :: R.Element -> DOM.Element -> Effect Unit
render e d = delay unit $ \_ -> pure $ R.reactDOM ... "render" $ args2 e d

paint :: Maybe Element -> Effect Unit
paint Nothing = log "[main] container not found"
paint (Just c) = render (app {} []) c

d3charge :: D3
d3charge = d3



    

      
      