module Phylo.Counter where

import Prelude

import Reactix as R
import Reactix.DOM.HTML as H
import Toestand as T
import Data.Tuple.Nested ((/\))

counterR :: R.Element
counterR = counter {initialCount : 0}

type Counter = ( initialCount :: Int )

counter :: Record Counter -> R.Element
counter props = R.createElement counterCpt props []

counterCpt :: R.Component Counter
counterCpt = R.hooksComponent "counter" cpt where
  cpt { initialCount } _children = do
    (count /\ setCount ) <- R.useState' initialCount
    pure $ H.div {}
      [ H.button { on: {click: \_event -> setCount (_ + 1) } }
        [H.text "Click here"]
        ,H.text ("You clicked " <> show count <> " times :)")]