module Phylo.Isoline where

import Graphics.D3.Base
import Prelude

import DOM.Simple.Console (log, log2)
import DOM.Simple.Element as DSE
import Data.Array (length)
import Data.Int (toNumber, round)
import Data.Maybe (Maybe(..), fromMaybe, maybe)
import Data.Nullable (null, toMaybe)
import Effect (Effect)
import Effect.Aff (Aff, launchAff_)
import Effect.Class (liftEffect)
import FFI.Simple (delay)
import Graphics.D3.Base (D3Eff)
import Graphics.D3.Contour as Contour
import Graphics.D3.Selection as Selection
import Phylo.TypesExample as PTE
import Reactix as R
import Reactix.DOM.HTML as H
import Toestand as T

foreign import drawIsoline :: Array PTE.PhyloObject -> String -> Effect Unit

type Props = ()

isolineR :: R.Element
isolineR = isoline {}

isoline :: Record Props -> R.Element
isoline props = R.createElement isolineCpt props []

isolineCpt :: R.Component Props
isolineCpt = R.hooksComponent "isoline" cpt where
  cpt {  } _children = do
    fetched <- T.useBox Nothing

    R.useEffect' $ do
      launchAff_ $ do        
        mr <- PTE.fetchPhyloJSON
        liftEffect $ do
          case mr of
            Nothing -> log "Nothing"
            Just r -> T.write_ (Just r) fetched
    pure $ isolineLoaded { fetched } []

type IsolineLoaded =
  ( fetched :: T.Box (Maybe PTE.PhyloJSON))

isolineLoaded :: Record IsolineLoaded -> Array R.Element -> R.Element
isolineLoaded = R.createElement isolineLoadedCpt

isolineLoadedCpt :: R.Component IsolineLoaded
isolineLoadedCpt = R.hooksComponent "isolineLoaded" cpt where
  cpt { fetched } _ = do
    fetched' <- T.useLive T.unequal fetched
    containerRef <- R.useRef null
    case fetched' of
      Nothing -> pure $ H.div{}[]
      Just mr -> do
--        R.useEffectOnce' $ do
--          delay unit $ \_ -> do
--            let mContainer = toMaybe $ R.readRef containerRef
--            case mContainer of
--              Nothing -> pure unit
--              Just cr -> do
--                drawIsoline (PTE.getBranches mr.objects) "phyloIsoline"
        pure $ H.div {id:"phyloIsoline", ref: containerRef}[H.text "Isoline"]
--      pure $ H.div {className:"phyloIsoline"}[H.text "Here lies the isoline"]