module Phylo.Graph where

import Prelude

import DOM.Simple.Console (log)
import Data.Array (length)
import Data.Int (toNumber, round)
import Data.Maybe (Maybe(..), fromMaybe, maybe)
import Data.Nullable (null, toMaybe)
import Effect.Aff (Aff, launchAff_)
import FFI.Simple (delay)
import Graphics.D3.Base (D3Eff)
import Graphics.D3.Contour as Contour
import Graphics.D3.Selection as Selection
import Phylo.TypesExample as PTE
import Reactix as R
import Reactix.DOM.HTML as H
import Toestand as T

phyloR :: R.Element
phyloR = phyloGraph { branches       : [10,20,30,40]
                     ,periods        : [10,20,30,40]
                     ,groups         : [10,20,30,40]
                     ,link           : [10,20,30,40]
                     ,branchLink     : [10,20,30,40]
                     ,ancestorLink   : [10,20,30,40] }

type PhyloGraph = 
  ( branches :: Array Int
  , periods :: Array Int
  , groups :: Array Int
  , link :: Array Int
  , branchLink :: Array Int
  , ancestorLink :: Array Int
  )

phyloGraph :: Record PhyloGraph -> R.Element
phyloGraph props = R.createElement phyloGraphCpt props []

phyloGraphCpt :: R.Component PhyloGraph
phyloGraphCpt = R.hooksComponent "phyloGraph" cpt where
  cpt {} _ = do
    pure $ H.div {className:"phyloGraph"} [H.text "Here lies Graph"]

timelineR :: R.Element
timelineR = timeline {}

timeline :: {} -> R.Element
timeline props = R.createElement timelineCpt props []

timelineCpt :: R.Component()
timelineCpt = R.hooksComponent "timeline" cpt where
  cpt {} _ = do
    pure $ H.div {className:"phyloTimeline"} [H.text "Here lies timeline"]

wordcloudR :: R.Element
wordcloudR = wordcloud {}

wordcloud :: {} -> R.Element
wordcloud props = R.createElement wordcloudCpt props []

wordcloudCpt :: R.Component()
wordcloudCpt = R.hooksComponent "wordcloud" cpt where
  cpt {} _ = do
    pure $ H.div {className:"phyloWordcloud"} [H.text "Here lies wordcloud"]
