module Phylo.Utils where

import Prelude

import DOM.Simple.Console (log, log2)
import Data.Array (length)
import Data.Int (toNumber, round)
import Data.Maybe (Maybe(..), isJust, maybe)
import Data.Nullable (null, toMaybe)
import Effect (Effect)
import Effect.Aff (Aff, killFiber, launchAff, launchAff_)
import Effect.Class (liftEffect)
import Effect.Exception (error)
import FFI.Simple (delay)
import Graphics.D3.Base (D3Eff)
import Graphics.D3.Contour as Contour
import Graphics.D3.Selection as Selection
import Phylo.TypesExample as PTE
import Reactix as R
import Reactix.DOM.HTML as H
import Toestand as T

-- useLoader functions

--type LoaderProps path st =
--  ( path   :: path
--  , render :: st -> R.Element
--  , state  :: T.Box (Maybe st) )
--
--loaderR :: R.Element
--loaderR = loader {path : path, render : --st, state : box}
--
--loader :: forall path st. Eq path => Eq --st => R.Component (LoaderProps path st)
--loader = R.createElement loaderCpt
--
--loaderCpt :: forall path st. Eq path => --Eq st => R.Component (LoaderProps path --st)
--loaderCpt = R.hooksComponent "loader" cpt
--  where
--    cpt { path, render, state } _ = do
--      state' <- T.useLive T.unequal state
--
--      pure $ maybe (loadingSpinner {}) --render state'
--
--useLoader :: forall path st. Eq path => --Eq st
--          => path
--          -> (path -> Aff st)
--          -> (st -> R.Element)
--          -> R.Hooks R.Element
--useLoader path loader' render = do
--  state <- T.useBox Nothing
--
--  useLoaderEffect path state loader'
--
--  pure $ loader { path, render, state } --[]
--
--affEffect :: forall a. String -> Aff a ---> Effect (Effect Unit)
--affEffect errmsg aff = do
--    fiber <- launchAff aff
--    pure $ launchAff_ $ killFiber (error --errmsg) fiber
--
--useLoaderEffect :: forall st path. Eq --path => Eq st =>
--                      path
--                   -> T.Box (Maybe st)
--                   -> (path -> Aff st)
--                   -> R.Hooks Unit
--useLoaderEffect path state loader = do
--  state' <- T.useLive T.unequal state
--  oPath <- R.useRef path
--  R.useEffect' $ do
--    path' <- R.readRefM oPath
--    if (path' == path) && (isJust state')
--    then pure $ R.nothing
--    else do
--      R.setRef oPath path
--      affEffect "G.H.Loader.--useLoaderEffect" $ do
--        l <- loader path
--        liftEffect $ T.write_ (Just l) --state
--
---- Loading spinner component
--
--type Props = ()
--
--loadingSpinner :: Record Props -> R.--Element
--loadingSpinner props = R.createElement --loadingSpinnerCpt props []
--
--loadingSpinnerCpt :: R.Component Props
--loadingSpinnerCpt = R.hooksComponent --"LoadingSpinner" cpt
--  where
--    cpt _ _ = do
--      pure $ H.i {className: "loading"} [H.text "Loading occuring"]